View a markdown version of this page

UpdateAgentGoal - AWS Well-Architected

UpdateAgentGoal

Note

AWS Well-Architected Agent is in preview release and is subject to change.

Updates the pillars and title of an existing goal associated with a profile.

Request Syntax

PUT /api/v1/agent-profiles/profileArn/goals/id HTTP/1.1 Content-type: application/json { "clientToken": "string", "description": "string", "pillars": [ "string" ], "title": "string" }

URI Request Parameters

The request uses the following URI parameters.

id

The unique identifier of the goal to update.

Pattern: [0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}

Required: Yes

profileArn

The Amazon Resource Name (ARN) of the profile containing the goal to update.

Length Constraints: Minimum length of 0. Maximum length of 2048.

Pattern: arn:aws([a-z0-9-]+)?:wellarchitected:[a-z0-9-]{6,64}:\d{12}:agent-profile/([a-zA-Z0-9_-]+)

Required: Yes

Request Body

The request accepts the following data in JSON format.

clientToken

A unique, case-sensitive identifier that you provide to ensure the idempotency of the request.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 128.

Pattern: [\x21-\x7E]+

Required: No

description

A description of the goal.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 4000.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])+

Required: No

pillars

The updated pillars for the goal. Pillars define the optimization focus areas such as cost, performance, resilience, and operational excellence.

Type: Array of strings

Array Members: Minimum number of 1 item. Maximum number of 5 items.

Valid Values: COST_OPTIMIZATION | SECURITY | RESILIENCE | PERFORMANCE | OPERATIONAL_EXCELLENCE

Required: No

title

The updated title for the goal. Maximum length of 1000 characters.

Type: String

Length Constraints: Minimum length of 1. Maximum length of 1000.

Pattern: (?:(?!\$\{[a-zA-Z]+:)[\P{C}])+

Required: No

Response Syntax

HTTP/1.1 200 Content-type: application/json { "goal": { "createdAt": "string", "createdBy": "string", "description": "string", "id": "string", "lastModifiedAt": "string", "lastModifiedBy": "string", "pillars": [ "string" ], "profileArn": "string", "title": "string" } }

Response Elements

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

goal

The updated goal summary.

Type: GoalSummary object

Errors

For information about the errors that are common to all actions, see Common Error Types.

AccessDeniedException

User does not have sufficient access to perform this action.

Message

Description of the error.

HTTP Status Code: 403

InternalServerException

There is a problem with the AWS Well-Architected Tool API service.

Message

Description of the error.

HTTP Status Code: 500

ResourceNotFoundException

The requested resource was not found.

Message

Description of the error.

ResourceId

Identifier of the resource affected.

ResourceType

Type of the resource affected.

HTTP Status Code: 404

ThrottlingException

Request was denied due to request throttling.

Message

Description of the error.

QuotaCode

Service Quotas requirement to identify originating quota.

ServiceCode

Service Quotas requirement to identify originating service.

HTTP Status Code: 429

ValidationException

The user input is not valid.

Fields

The fields that caused the error, if applicable.

Message

Description of the error.

Reason

The reason why the request failed validation.

HTTP Status Code: 400

See Also

For more information about using this API in one of the language-specific AWS SDKs, see the following: